-- Davy Crockett script by Cyber
-- Based on minigun script by Tuxedo Labs

function init()
	RegisterTool("DavyCrockett", "DavyCrockett", "MOD/vox/DavyCrockett.vox")
	SetBool("game.tool.DavyCrockett.enabled", true)
	SetFloat("game.tool.DavyCrockett.ammo", 5)
	unlimitedammo = GetBool("savegame.mod.unlimitedammo")
	lowlag = GetBool("savegame.mod.lowlag")
	noflash = GetBool("savegame.mod.noflash")
	
	angle = 0
	angVel = 0
	coolDown = 0
	smoke = 0
	spareammo = 4
	magammo = 1
	relTime = 0
	reloading = 0 
	nuketime = 0
	nukeloc = 0
	nukecount = 0
	gunSnd = LoadSound("MOD/snd/rocketfire.ogg")
	gunRel = LoadSound("MOD/snd/reload.ogg")
	nukesound = LoadSound("MOD/snd/nukesound.ogg")
	
	oldPipePos = Vec()
	particleTimer = 0
	
	
	
end

function rndVec(length)
	local v = VecNormalize(Vec(math.random(-100,100), math.random(-100,100), math.random(-100,100)))
	return VecScale(v, length)	
end

function rnd(mi, ma)
	return math.random(1000)/1000*(ma-mi) + mi
end

function tick(dt)

	if GetString("game.player.tool") == "DavyCrockett" then
	
        nuketime = nuketime - dt
		
		local ct = GetCameraTransform()
		
		if magammo == 0 then
			local b = GetToolBody()
				local shapes = GetBodyShapes(b)
		
				if b ~= body then
					body = b
					t0 = GetShapeLocalTransform(shapes[2])
				end

				t = TransformCopy(t0)
				t.pos = VecAdd(t.pos, Vec(0,0,3))
				SetShapeLocalTransform(shapes[2], t)
		end	
		
		if magammo > 0 and coolDown > 0 then
			local b = GetToolBody()
			local shapes = GetBodyShapes(b)
			if b ~= body then
				body = b
				    t0 = GetShapeLocalTransform(shapes[2])
			end

			t = TransformCopy(t0)
			t.pos = VecAdd(t.pos, Vec(0,0,0))
			SetShapeLocalTransform(shapes[2], t)
		end
        
		reload()
		nuke()
		relTime = relTime - dt
		
		if GetBool("game.player.canusetool") and InputDown("usetool") and magammo > 0 and reloading == 0 then
		        
				if coolDown < 0 then
				    local t = GetCameraTransform()
					local fwd = TransformToParentVec(t, Vec(0, 0, -1))
				    local maxDist = 1500
				    local hit, dist, normal, shape = QueryRaycast(t.pos, fwd, maxDist)
				    if not hit then
					    dist = maxDist
				    end
					local s = VecAdd(VecAdd(t.pos, Vec(0, -0.5, 0)),VecScale(fwd, 1.5))
				    local e = VecAdd(t.pos, VecScale(fwd, dist))
					local p = TransformToParentPoint(ct, Vec(0.25, -0.25, -1.55))
					local d = VecAdd(TransformToParentVec(ct, Vec(0,0,-1)), rndVec(0.005))
					Shoot(p, d)

					local lp = TransformToParentPoint(ct, Vec(0.25, -0.25, -2.0))
					PointLight(lp, 1, 0.7, 0.5, 3)
					PlaySound(gunSnd)	                
					
					if hit then
					
					    nukeloc = e
						nuketime = 4
						stageone = 1
						nukecount = 1
						
				    end

					smoke = math.min(1.0, smoke + .5)
					coolDown = 1
		            magammo = magammo - 1

					local b = GetToolBody()
					local shapes = GetBodyShapes(b)
			
			        if b ~= body then
				        body = b
				        t0 = GetShapeLocalTransform(shapes[2])
			        end

			        t = TransformCopy(t0)
			        t.pos = VecAdd(t.pos, Vec(0,0,3))
			        SetShapeLocalTransform(shapes[2], t)
				end
			
	end
	
		local p = TransformToParentPoint(ct, Vec(0.25, -0.3, -1.9))
		if not InputDown("lmb") then
			if smoke > 0 then
				if particleTimer < 0.0 then
					particleTimer = dt + (1.0-smoke)*0.05
					local vel = VecScale(VecSub(p, oldPipePos), 0.5/ dt)
					vel = VecAdd(vel, Vec(0, rnd(0, 2), 0))
					ParticleType("smoke")
					ParticleRadius(0.08, 0.15)
					ParticleAlpha(smoke*0.4, 0)
					ParticleDrag(15)
					SpawnParticle(p, VecAdd(vel, rndVec(0.1)), 2.0)
					
				end
			end
		end
		particleTimer = particleTimer - dt
		oldPipePos = p
	
		coolDown = coolDown - dt
		angle = angle + angVel*dt
		
		local t = Transform()
		local recoil = math.max(0, coolDown)
		t.pos = Vec(0.3, 0, recoil)
		SetToolTransform(t)
	end
	smoke = math.max(0.0, smoke - dt/3)
end


function draw()
	if GetString("game.player.tool") == "DavyCrockett" and GetPlayerVehicle() == 0 then
		UiPush()
			UiTranslate(UiCenter(), UiHeight()-60)
			UiAlign("center middle")
			UiColor(1, 1, 1)
			UiFont("bold.ttf", 32)
			UiTextOutline(0,0,0,1,0.1)
			if reloading == 0 then
			    UiText(magammo.."/"..spareammo)
			else
			    UiText("RELOADING".." "..(math.floor(relTime * 10) /10))
			end 
		if nuketime > 1.5 and nuketime < 2.2 and not noflash then
            UiTranslate(UiCenter(), UiMiddle())
	        UiAlign("center middle")
	        UiImage("MOD/Flash/Flash.png")
        end
		UiPop()
	end
end

function reload()
	if InputDown("r") and reloading == 0 and spareammo > 0 and magammo < 1 then
	    reloading = 1
	    relTime = 3
		PlaySound(gunRel)
	end
	
	if relTime < 0 and reloading == 1 then
	    
	    if magammo == 0 and spareammo > 0 then
	        local b = GetToolBody()
		    local shapes = GetBodyShapes(b)
			
			if b ~= body then
				body = b
				    t0 = GetShapeLocalTransform(shapes[2])
			    end

		    t = TransformCopy(t0)
		    t.pos = VecAdd(t.pos, Vec(0,0,0))
		    SetShapeLocalTransform(shapes[2], t)
	    end	
	--	
		if not unlimitedammo and magammo < 1 and spareammo > 0 then
            magammo = spareammo + magammo
			spareammo = 0
			if magammo > 1 then
			    spareammo = magammo - 1
				magammo = 1
			end			
		else
		    magammo = 1
		end
        reloading = 0
        		
	end
end

function nuke()

    if nuketime > 2 and nuketime < 2.2 then
	    if nukecount == 1 then
		
		    
			PlaySound(nukesound)
			local intensity = 15000 + math.sin(GetTime())
			r = VecAdd (nukeloc, Vec(0, 8, 0))
			PointLight(r, 1, 1, 0, intensity)
			local intensity = 1000 + math.sin(GetTime())
			r = VecAdd (nukeloc, Vec(0, 8, 0))
			PointLight(r, 1, 1, 0, intensity)
			
            if not lowlag then
			MakeHole(e, 11.0, 10.0, 9.0)
			r = VecAdd (nukeloc, Vec(11, 0, 0))
			Explosion(r, 4)
			r = VecAdd (nukeloc, Vec(-11, 0, 0))
			Explosion(r, 4)
			r = VecAdd (nukeloc, Vec(0, 0, -11))
			Explosion(r, 4)
			r = VecAdd (nukeloc, Vec(0, 0, 11))
			Explosion(r, 4)
			r = VecAdd (nukeloc, Vec(11, 0, -11))
			Explosion(r, 4)
			r = VecAdd (nukeloc, Vec(-11, 0, 11))
			Explosion(r, 4)
			r = VecAdd (nukeloc, Vec(-11, 0, -11))
			Explosion(r, 4)
			r = VecAdd (nukeloc, Vec(11, 0, 11))
			Explosion(r, 4)
			r = VecAdd (nukeloc, Vec(0, 0, 0))
			Explosion(r, 4)	
            else
            MakeHole(nukeloc, 11.0, 10.0, 9.0)
			Explosion(nukeloc, 4)
            end			


			ParticleType("plain")
			ParticleCollide(0)
			ParticleRadius(5.0)
			ParticleDrag(1)
			ParticleEmissive(3, 0)
			ParticleAlpha(5.0 , 0.0)
			r = VecAdd (nukeloc, Vec(5, -.2, 0))
			SpawnParticle(r, VecAdd(0,0,0), 40.0)
			r = VecAdd (nukeloc, Vec(0, -.2, 5))
			SpawnParticle(r, VecAdd(0,0,0), 40.0)
			r = VecAdd (nukeloc, Vec(-5, -.2, 0))
			SpawnParticle(r, VecAdd(0,0,0), 40.0)
			r = VecAdd (nukeloc, Vec(0, -.2, -5))
			SpawnParticle(r, VecAdd(0,0,0), 40.0)
			ParticleRadius(3.0)

			r = VecAdd (nukeloc, Vec(0, 3, 0))
			SpawnParticle(r, VecAdd(0,0,0), 30.0)
			r = VecAdd (nukeloc, Vec(0, 6, 0))
			SpawnParticle(r, VecAdd(0,0,0), 30.0)
			r = VecAdd (nukeloc, Vec(0, 9, 0))
			SpawnParticle(r, VecAdd(0,0,0), 30.0)
			r = VecAdd (nukeloc, Vec(0, 12, 0))
			SpawnParticle(r, VecAdd(0,0,0), 30.0)
			ParticleGravity(.5)
			r = VecAdd (nukeloc, Vec(0, 9, 0))
			SpawnParticle(r, VecAdd(0,0,0), 30.0)
			r = VecAdd (nukeloc, Vec(0, 12, 0))
			SpawnParticle(r, VecAdd(0,0,0), 30.0)
			r = VecAdd (nukeloc, Vec(0, 15, 0))
			SpawnParticle(r, VecAdd(0,0,0), 30.0)
			r = VecAdd (nukeloc, Vec(0, 18, 0))
			SpawnParticle(r, VecAdd(0,0,0), 30.0)
			r = VecAdd (nukeloc, Vec(0, 21, 0))

			ParticleGravity(3)
			ParticleRadius(8.0)
			ParticleRotation(.2)
			r = VecAdd (nukeloc, Vec(8, 9, 0))
			SpawnParticle(r, VecAdd(0,0,0), 30.0)
			r = VecAdd (nukeloc, Vec(0, 9, 8))
			SpawnParticle(r, VecAdd(0,0,0), 30.0)
			ParticleRotation(-.2)
			r = VecAdd (nukeloc, Vec(-8, 9, 0))
			SpawnParticle(r, VecAdd(0,0,0), 30.0)
			r = VecAdd (nukeloc, Vec(0, 9, -8))
			SpawnParticle(r, VecAdd(0,0,0), 30.0)

			r = VecAdd (nukeloc, Vec(0, 9, 0))
			SpawnParticle(r, VecAdd(0,0,0), 30.0)
			r = VecAdd (nukeloc, Vec(0, 12, 0))
			SpawnParticle(r, VecAdd(0,0,0), 30.0)

			nukecount = 0
		end 
    end
						

end
